/* 
*
*  ProLinga-Run
*
*  Copyright (C) 2002-2008 Xobas Software.
*  All rights reserved.
*  
*  This file is part of ProLinga-Run.
*
*  ProLinga-Run is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  ProLinga-Run is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with ProLinga-Run.  If not, see <http://www.gnu.org/licenses/>.
*
*  More information is available at the following addresses:
*
*  Website     : http://www.prolinga.org
*
*  Email       : prolinga-list@prolinga.org
*
*
*/

#ifndef __DATA_COMMAND_HPP
#define __DATA_COMMAND_HPP

xmlDocPtr DC_Exec(xmlDocPtr docReq);

xmlDocPtr dataConnect(void);

xmlDocPtr dataDisconnect(const char *sessionId);

xmlDocPtr dataOpenDataSource(const char *sessionId, const char *extName, const char *userName, const char *password, const char *readOnly, const char *share);

xmlDocPtr dataCloseDataSource(const char *sessionId, const char *extName);

xmlDocPtr dataManageData(const char *sessionId, const char *appnName, const char *dsrcExtName, const char *tableName, const int option);

int dataCreateDataSession(const char *dataSource);

int dataClearDataSession(const char *dataSource);

int dataExecuteAction(const char *dataSource, const char *sqlCommand);

int dataExecuteQueryDataModel(const char *dataSource, const char *sqlCommand, const char *dataModel);

int dataDataModelGetRow(const char *dataModel, const int rowNo);

int dataTransaction(const char *dataSource, const char *mode, const char *isolationLevel);

#endif /* __DATA_COMMAND_HPP */

